Orxonox: orxonox::ControllableEntity Class Reference

# orxonox::ControllableEntity Class Reference

`#include <src/orxonox/objects/worldentities/ControllableEntity.h>`

Inheritance diagram for orxonox::ControllableEntity:

List of all members.

## Public Member Functions

void | addCameraPosition (CameraPosition *position)
virtual void | boost ()
virtual void | changedPlayer ()
| ControllableEntity (BaseObject *creator)
virtual void | dropItems ()
virtual void | fire (unsigned int firemode)
Camera * | getCamera () const
CameraPosition * | getCameraPosition (unsigned int index) const
const std::list < CameraPosition * > & | getCameraPositions () const
const std::string & | getCameraPositionTemkplate () const
bool | getDestroyWhenPlayerLeft () const
OverlayGroup * | getHUD () const
const std::string & | getHudTemplate () const
float | getMouseLookSpeed () const
PlayerInfo * | getPlayer () const
CameraPosition * | getReverseCamera () const
Controller * | getXMLController () const
virtual void | greet ()
bool | hasHumanController () const
bool | hasLocalController () const
bool | isInMouseLook () const
virtual void | mouseLook ()
void | moveFrontBack (float value)
virtual void | moveFrontBack (const Vector2 &value)
void | moveRightLeft (float value)
virtual void | moveRightLeft (const Vector2 &value)
void | moveUpDown (float value)
virtual void | moveUpDown (const Vector2 &value)
void | registerVariables ()
virtual void | reload ()
void | rotatePitch (float value)
virtual void | rotatePitch (const Vector2 &value)
void | rotateRoll (float value)
virtual void | rotateRoll (const Vector2 &value)
void | rotateYaw (float value)
virtual void | rotateYaw (const Vector2 &value)
void | setAngularVelocity (const Vector3 &velocity)
void | setCameraPositionTemplate (const std::string &name)
void | setConfigValues ()
| Function to collect the SetConfigValue-macro calls.
void | setDestroyWhenPlayerLeft (bool bDestroy)
void | setOrientation (const Quaternion &orientation)
void | setPosition (const Vector3 &position)
void | setReverseCamera (CameraPosition *camera)
void | setVelocity (const Vector3 &velocity)
virtual void | switchCamera ()
virtual void | tick (float dt)
| Gets called every frame.
virtual void | useItem ()
virtual void | XMLPort (Element &xmlelement, XMLPort::Mode mode)
| XML loading and saving.
virtual | ~ControllableEntity ()

## Protected Member Functions

virtual void | parentChanged ()
virtual void | removePlayer ()
void | setHudTemplate (const std::string &name)
virtual void | setPlayer (PlayerInfo *player)
virtual void | startLocalHumanControl ()
virtual void | stopLocalHumanControl ()

## Private Member Functions

void | networkcallback_changedplayerID ()
void | overwrite ()
void | processClientAngularVelocity ()
void | processClientLinearVelocity ()
void | processClientOrientation ()
void | processClientPosition ()
void | processOverwrite ()
void | processServerAngularVelocity ()
void | processServerLinearVelocity ()
void | processServerOrientation ()
void | processServerPosition ()
void | setWorldTransform (const btTransform &worldTrans)
void | setXMLController (Controller *controller)

## Private Attributes

bool | bDestroyWhenPlayerLeft_
bool | bHasHumanController_
bool | bHasLocalController_
bool | bMouseLook_
Camera * | camera_
Ogre::SceneNode * | cameraPositionRootNode_
std::list< CameraPosition * > | cameraPositions_
std::string | cameraPositionTemplate_
Vector3 | client_angular_velocity_
Vector3 | client_linear_velocity_
Quaternion | client_orientation_
unsigned int | client_overwrite_
Vector3 | client_position_
OverlayGroup * | hud_
std::string | hudtemplate_
float | mouseLookSpeed_
PlayerInfo * | player_
unsigned int | playerID_
CameraPosition * | reverseCamera_
Vector3 | server_angular_velocity_
Vector3 | server_linear_velocity_
Quaternion | server_orientation_
unsigned int | server_overwrite_
Vector3 | server_position_
Controller * | xmlcontroller_

## Friends

class | PlayerInfo

## Constructor & Destructor Documentation

orxonox::ControllableEntity::ControllableEntity | ( | BaseObject * | creator | ) |

References bDestroyWhenPlayerLeft_, bHasHumanController_, bHasLocalController_, bMouseLook_, camera_, cameraPositionRootNode_, client_angular_velocity_, client_linear_velocity_, client_orientation_, client_overwrite_, client_position_, hud_, mouseLookSpeed_, orxonox::WorldEntity::node_, orxonox::OBJECTID_UNKNOWN, player_, playerID_, RegisterObject, registerVariables(), reverseCamera_, server_angular_velocity_, server_linear_velocity_, server_orientation_, server_overwrite_, server_position_, setConfigValues(), orxonox::Synchronisable::setPriority(), orxonox::Priority::VeryHigh, and xmlcontroller_.

orxonox::ControllableEntity::~ControllableEntity | ( |  | ) | `[virtual]`

References bDestroyWhenPlayerLeft_, bHasHumanController_, bHasLocalController_, camera_, cameraPositionRootNode_, cameraPositions_, getPlayer(), orxonox::BaseObject::getScene(), orxonox::Scene::getSceneManager(), hud_, orxonox::BaseObject::isInitialized(), orxonox::PlayerInfo::stopControl(), stopLocalHumanControl(), and xmlcontroller_.

## Member Function Documentation

void orxonox::ControllableEntity::addCameraPosition | ( | CameraPosition * | position | ) |

References orxonox::WorldEntity::attach(), orxonox::WorldEntity::attachToNode(), cameraPositions_, orxonox::CameraPosition::getAllowMouseLook(), orxonox::CameraPosition::getIsAbsolute(), orxonox::WorldEntity::getParent(), orxonox::CameraPosition::getRenderCamera(), and setReverseCamera().

Referenced by XMLPort().

virtual void orxonox::ControllableEntity::boost | ( |  | ) | `[inline, virtual]`

Reimplemented in orxonox::SpaceShip.

Referenced by orxonox::HumanController::boost().

virtual void orxonox::ControllableEntity::changedPlayer | ( |  | ) | `[inline, virtual]`

Reimplemented in orxonox::PongBat.

Referenced by removePlayer(), and setPlayer().

virtual void orxonox::ControllableEntity::dropItems | ( |  | ) | `[inline, virtual]`

Reimplemented in orxonox::Pawn.

Referenced by orxonox::HumanController::dropItems().

virtual void orxonox::ControllableEntity::fire | ( | unsigned int | firemode | ) | `[inline, virtual]`

Reimplemented in orxonox::Pawn, and orxonox::Spectator.

Referenced by orxonox::HumanController::fire(), orxonox::WaypointPatrolController::tick(), and orxonox::AIController::tick().

Camera* orxonox::ControllableEntity::getCamera | ( |  | ) | const`[inline]`

Referenced by orxonox::Gametype::end(), and orxonox::Gametype::pawnKilled().

CameraPosition * orxonox::ControllableEntity::getCameraPosition | ( | unsigned int | index | ) | const

References cameraPositions_.

Referenced by XMLPort().

const std::list<CameraPosition*>& orxonox::ControllableEntity::getCameraPositions | ( |  | ) | const`[inline]`

const std::string& orxonox::ControllableEntity::getCameraPositionTemkplate | ( |  | ) | const`[inline]`

Referenced by XMLPort().

bool orxonox::ControllableEntity::getDestroyWhenPlayerLeft | ( |  | ) | const`[inline]`

OverlayGroup* orxonox::ControllableEntity::getHUD | ( |  | ) | const`[inline]`

const std::string& orxonox::ControllableEntity::getHudTemplate | ( |  | ) | const`[inline]`

Referenced by XMLPort().

float orxonox::ControllableEntity::getMouseLookSpeed | ( |  | ) | const`[inline]`

Referenced by orxonox::Spectator::tick().

PlayerInfo* orxonox::ControllableEntity::getPlayer | ( |  | ) | const`[inline]`

Referenced by orxonox::UnderAttack::allowPawnDamage(), orxonox::UnderAttack::allowPawnDeath(), orxonox::TeamBaseMatch::allowPawnDeath(), orxonox::UnderAttack::allowPawnHit(), orxonox::Pawn::death(), orxonox::QuestEffectBeacon::execute(), orxonox::Spectator::fire(), orxonox::Pong::getLeftPlayer(), orxonox::Pong::getRightPlayer(), orxonox::Gametype::pawnKilled(), orxonox::Deathmatch::pawnKilled(), orxonox::Asteroids::pawnKilled(), orxonox::TeamDeathmatch::pawnsAreInTheSameTeam(), orxonox::TeamBaseMatch::pawnsAreInTheSameTeam(), orxonox::Pawn::removePlayer(), orxonox::ArtificialController::sameTeam(), and ~ControllableEntity().

CameraPosition* orxonox::ControllableEntity::getReverseCamera | ( |  | ) | const`[inline]`

Referenced by orxonox::Map::changedOwner().

Controller* orxonox::ControllableEntity::getXMLController | ( |  | ) | const`[inline]`

Referenced by orxonox::ArtificialController::sameTeam(), and XMLPort().

virtual void orxonox::ControllableEntity::greet | ( |  | ) | `[inline, virtual]`

Reimplemented in orxonox::Spectator.

Referenced by orxonox::HumanController::greet().

bool orxonox::ControllableEntity::hasHumanController | ( |  | ) | const`[inline]`

Referenced by orxonox::Engine::tick().

bool orxonox::ControllableEntity::hasLocalController | ( |  | ) | const`[inline]`

Referenced by orxonox::Pawn::Pawn(), orxonox::PongBat::tick(), orxonox::Spectator::tick(), orxonox::SpaceShip::tick(), and orxonox::Engine::tick().

bool orxonox::ControllableEntity::isInMouseLook | ( |  | ) | const`[inline]`

Referenced by orxonox::HumanController::rotatePitch(), orxonox::HumanController::rotateYaw(), orxonox::Spectator::tick(), and orxonox::SpaceShip::tick().

void orxonox::ControllableEntity::mouseLook | ( |  | ) | `[virtual]`

References bMouseLook_, and cameraPositionRootNode_.

Referenced by orxonox::HumanController::mouseLook().

void orxonox::ControllableEntity::moveFrontBack | ( | float | value | ) | `[inline]`

References orxonox::MT_Type::Vector2.

virtual void orxonox::ControllableEntity::moveFrontBack | ( | const Vector2 & | value | ) | `[inline, virtual]`

Reimplemented in orxonox::SpaceShip, orxonox::Spectator, and orxonox::PongBat.

Referenced by orxonox::HumanController::moveFrontBack(), orxonox::ArtificialController::moveToPosition(), and orxonox::PongAI::tick().

void orxonox::ControllableEntity::moveRightLeft | ( | float | value | ) | `[inline]`

References orxonox::MT_Type::Vector2.

virtual void orxonox::ControllableEntity::moveRightLeft | ( | const Vector2 & | value | ) | `[inline, virtual]`

Reimplemented in orxonox::SpaceShip, orxonox::Spectator, and orxonox::PongBat.

Referenced by orxonox::HumanController::moveRightLeft().

void orxonox::ControllableEntity::moveUpDown | ( | float | value | ) | `[inline]`

References orxonox::MT_Type::Vector2.

virtual void orxonox::ControllableEntity::moveUpDown | ( | const Vector2 & | value | ) | `[inline, virtual]`

Reimplemented in orxonox::SpaceShip, and orxonox::Spectator.

Referenced by orxonox::HumanController::moveUpDown().

void orxonox::ControllableEntity::networkcallback_changedplayerID | ( |  | ) | `[private]`

References orxonox::PlayerInfo::getControllableEntity(), orxonox::Synchronisable::getSynchronisable(), orxonox::OBJECTID_UNKNOWN, player_, playerID_, and orxonox::PlayerInfo::startControl().

Referenced by registerVariables().

void orxonox::ControllableEntity::overwrite | ( |  | ) | `[private]`

void orxonox::ControllableEntity::parentChanged | ( |  | ) | `[protected, virtual]`

Reimplemented from orxonox::WorldEntity.

References orxonox::WorldEntity::attach(), cameraPositions_, orxonox::WorldEntity::getParent(), and orxonox::WorldEntity::parentChanged().

void orxonox::ControllableEntity::processClientAngularVelocity | ( |  | ) | `[private]`

References client_angular_velocity_, client_overwrite_, orxonox::MobileEntity::getAngularVelocity(), server_angular_velocity_, server_overwrite_, and orxonox::MobileEntity::setAngularVelocity().

Referenced by registerVariables().

void orxonox::ControllableEntity::processClientLinearVelocity | ( |  | ) | `[private]`

References client_linear_velocity_, client_overwrite_, orxonox::MobileEntity::getVelocity(), server_linear_velocity_, server_overwrite_, and orxonox::MobileEntity::setVelocity().

Referenced by registerVariables().

void orxonox::ControllableEntity::processClientOrientation | ( |  | ) | `[private]`

References client_orientation_, client_overwrite_, orxonox::WorldEntity::getOrientation(), server_orientation_, server_overwrite_, and orxonox::MobileEntity::setOrientation().

Referenced by registerVariables().

void orxonox::ControllableEntity::processClientPosition | ( |  | ) | `[private]`

References client_overwrite_, client_position_, orxonox::WorldEntity::getPosition(), server_overwrite_, server_position_, and orxonox::MobileEntity::setPosition().

Referenced by registerVariables().

void orxonox::ControllableEntity::processOverwrite | ( |  | ) | `[private]`

References bHasLocalController_, client_overwrite_, server_angular_velocity_, server_linear_velocity_, server_orientation_, server_overwrite_, server_position_, setAngularVelocity(), setOrientation(), setPosition(), and setVelocity().

Referenced by registerVariables().

void orxonox::ControllableEntity::processServerAngularVelocity | ( |  | ) | `[private]`

References bHasLocalController_, server_angular_velocity_, and orxonox::MobileEntity::setAngularVelocity().

Referenced by registerVariables().

void orxonox::ControllableEntity::processServerLinearVelocity | ( |  | ) | `[private]`

References bHasLocalController_, server_linear_velocity_, and orxonox::MobileEntity::setVelocity().

Referenced by registerVariables().

void orxonox::ControllableEntity::processServerOrientation | ( |  | ) | `[private]`

References bHasLocalController_, server_orientation_, and orxonox::MobileEntity::setOrientation().

Referenced by registerVariables().

void orxonox::ControllableEntity::processServerPosition | ( |  | ) | `[private]`

References bHasLocalController_, server_position_, and orxonox::MobileEntity::setPosition().

Referenced by registerVariables().

void orxonox::ControllableEntity::registerVariables | ( |  | ) |

Reimplemented from orxonox::WorldEntity.

Reimplemented in orxonox::Pawn, orxonox::SpaceShip, orxonox::Spectator, and orxonox::PongBat.

References cameraPositionTemplate_, client_angular_velocity_, client_linear_velocity_, client_orientation_, client_overwrite_, client_position_, hudtemplate_, networkcallback_changedplayerID(), playerID_, processClientAngularVelocity(), processClientLinearVelocity(), processClientOrientation(), processClientPosition(), processOverwrite(), processServerAngularVelocity(), processServerLinearVelocity(), processServerOrientation(), processServerPosition(), orxonox::Synchronisable::registerVariable(), server_angular_velocity_, server_linear_velocity_, server_orientation_, server_overwrite_, server_position_, orxonox::VariableDirection::ToClient, and orxonox::VariableDirection::ToServer.

Referenced by ControllableEntity().

virtual void orxonox::ControllableEntity::reload | ( |  | ) | `[inline, virtual]`

Reimplemented in orxonox::Pawn.

Referenced by orxonox::HumanController::reload().

void orxonox::ControllableEntity::removePlayer | ( |  | ) | `[protected, virtual]`

Reimplemented in orxonox::Pawn.

References bDestroyWhenPlayerLeft_, bHasHumanController_, bHasLocalController_, changedPlayer(), orxonox::OBJECTID_UNKNOWN, player_, playerID_, orxonox::Synchronisable::setObjectMode(), stopLocalHumanControl(), and orxonox::ObjectDirection::ToClient.

Referenced by orxonox::Pawn::removePlayer(), setPlayer(), and orxonox::PlayerInfo::stopControl().

void orxonox::ControllableEntity::rotatePitch | ( | float | value | ) | `[inline]`

References orxonox::MT_Type::Vector2.

void orxonox::ControllableEntity::rotatePitch | ( | const Vector2 & | value | ) | `[virtual]`

Reimplemented in orxonox::SpaceShip, and orxonox::Spectator.

References bMouseLook_, cameraPositionRootNode_, and orxonox::MT_Type::Radian.

Referenced by orxonox::ArtificialController::moveToPosition(), orxonox::Spectator::rotatePitch(), orxonox::SpaceShip::rotatePitch(), and orxonox::HumanController::rotatePitch().

void orxonox::ControllableEntity::rotateRoll | ( | float | value | ) | `[inline]`

References orxonox::MT_Type::Vector2.

void orxonox::ControllableEntity::rotateRoll | ( | const Vector2 & | value | ) | `[virtual]`

Reimplemented in orxonox::SpaceShip, and orxonox::Spectator.

References bMouseLook_, cameraPositionRootNode_, and orxonox::MT_Type::Radian.

Referenced by orxonox::Spectator::rotateRoll(), orxonox::SpaceShip::rotateRoll(), and orxonox::HumanController::rotateRoll().

void orxonox::ControllableEntity::rotateYaw | ( | float | value | ) | `[inline]`

References orxonox::MT_Type::Vector2.

void orxonox::ControllableEntity::rotateYaw | ( | const Vector2 & | value | ) | `[virtual]`

Reimplemented in orxonox::SpaceShip, and orxonox::Spectator.

References bMouseLook_, cameraPositionRootNode_, and orxonox::MT_Type::Radian.

Referenced by orxonox::ArtificialController::moveToPosition(), orxonox::Spectator::rotateYaw(), orxonox::SpaceShip::rotateYaw(), and orxonox::HumanController::rotateYaw().

void orxonox::ControllableEntity::setAngularVelocity | ( | const Vector3 & | velocity | ) | `[virtual]`

Reimplemented from orxonox::MobileEntity.

References bHasLocalController_, client_angular_velocity_, orxonox::MobileEntity::getAngularVelocity(), orxonox::GameMode::isMaster(), server_angular_velocity_, server_overwrite_, and orxonox::MobileEntity::setAngularVelocity().

Referenced by processOverwrite().

void orxonox::ControllableEntity::setCameraPositionTemplate | ( | const std::string & | name | ) | `[inline]`

Referenced by XMLPort().

void orxonox::ControllableEntity::setConfigValues | ( |  | ) |

Function to collect the SetConfigValue-macro calls.

Reimplemented from orxonox::OrxonoxClass.

Reimplemented in orxonox::SpaceShip, and orxonox::Spectator.

References mouseLookSpeed_, and SetConfigValue.

Referenced by ControllableEntity().

void orxonox::ControllableEntity::setDestroyWhenPlayerLeft | ( | bool | bDestroy | ) | `[inline]`

Referenced by orxonox::Pawn::death(), orxonox::Pawn::goWithStyle(), orxonox::SpaceShip::SpaceShip(), and orxonox::Spectator::Spectator().

void orxonox::ControllableEntity::setHudTemplate | ( | const std::string & | name | ) | `[inline, protected]`

Referenced by orxonox::Spectator::Spectator(), and XMLPort().

void orxonox::ControllableEntity::setOrientation | ( | const Quaternion & | orientation | ) | `[virtual]`

Reimplemented from orxonox::MobileEntity.

References bHasLocalController_, client_orientation_, orxonox::WorldEntity::getOrientation(), orxonox::GameMode::isMaster(), server_orientation_, server_overwrite_, and orxonox::MobileEntity::setOrientation().

Referenced by orxonox::Gametype::end(), orxonox::Gametype::pawnKilled(), processOverwrite(), and orxonox::SpawnPoint::spawn().

void orxonox::ControllableEntity::setPlayer | ( | PlayerInfo * | player | ) | `[protected, virtual]`

Reimplemented in orxonox::Pawn, and orxonox::Spectator.

References bHasHumanController_, bHasLocalController_, orxonox::ObjectDirection::Bidirectional, changedPlayer(), client_overwrite_, orxonox::Synchronisable::getObjectID(), orxonox::PlayerInfo::isHumanPlayer(), orxonox::PlayerInfo::isLocalPlayer(), orxonox::GameMode::isMaster(), player_, playerID_, removePlayer(), server_overwrite_, orxonox::Synchronisable::setObjectMode(), and startLocalHumanControl().

Referenced by orxonox::Spectator::setPlayer(), orxonox::Pawn::setPlayer(), and orxonox::PlayerInfo::startControl().

void orxonox::ControllableEntity::setPosition | ( | const Vector3 & | position | ) | `[virtual]`

Reimplemented from orxonox::MobileEntity.

References bHasLocalController_, client_position_, orxonox::WorldEntity::getPosition(), orxonox::GameMode::isMaster(), server_overwrite_, server_position_, and orxonox::MobileEntity::setPosition().

Referenced by orxonox::Gametype::end(), orxonox::Gametype::pawnKilled(), orxonox::Pong::playerScored(), processOverwrite(), orxonox::SpawnPoint::spawn(), orxonox::Pong::start(), and orxonox::PongBat::tick().

void orxonox::ControllableEntity::setReverseCamera | ( | CameraPosition * | camera | ) | `[inline]`

Referenced by addCameraPosition().

void orxonox::ControllableEntity::setVelocity | ( | const Vector3 & | velocity | ) | `[virtual]`

Reimplemented from orxonox::MobileEntity.

References bHasLocalController_, client_linear_velocity_, orxonox::MobileEntity::getVelocity(), orxonox::GameMode::isMaster(), server_linear_velocity_, server_overwrite_, and orxonox::MobileEntity::setVelocity().

Referenced by orxonox::PongBat::changedPlayer(), orxonox::Pawn::hit(), processOverwrite(), orxonox::PongBat::tick(), orxonox::Spectator::tick(), and orxonox::Jump::used().

void orxonox::ControllableEntity::setWorldTransform | ( | const btTransform & | worldTrans | ) | `[private, virtual]`

Reimplemented from orxonox::MobileEntity.

References bHasLocalController_, client_angular_velocity_, client_linear_velocity_, client_orientation_, client_position_, orxonox::MobileEntity::getAngularVelocity(), orxonox::WorldEntity::getOrientation(), orxonox::WorldEntity::getPosition(), orxonox::MobileEntity::getVelocity(), orxonox::GameMode::isMaster(), server_angular_velocity_, server_linear_velocity_, server_orientation_, server_position_, and orxonox::MobileEntity::setWorldTransform().

void orxonox::ControllableEntity::setXMLController | ( | Controller * | controller | ) | `[private]`

References bHasLocalController_, COUT, orxonox::BaseObject::getName(), orxonox::Controller::setControllableEntity(), and xmlcontroller_.

Referenced by XMLPort().

void orxonox::ControllableEntity::startLocalHumanControl | ( |  | ) | `[protected, virtual]`

Reimplemented in orxonox::Pawn, and orxonox::Spectator.

References orxonox::BaseObject::addTemplate(), orxonox::WorldEntity::attachToNode(), camera_, cameraPositionRootNode_, cameraPositions_, cameraPositionTemplate_, hud_, hudtemplate_, orxonox::Camera::requestFocus(), and orxonox::OverlayGroup::setOwner().

Referenced by setPlayer(), orxonox::Spectator::startLocalHumanControl(), and orxonox::Pawn::startLocalHumanControl().

void orxonox::ControllableEntity::stopLocalHumanControl | ( |  | ) | `[protected, virtual]`

References camera_, orxonox::WorldEntity::detachFromParent(), and hud_.

Referenced by removePlayer(), and ~ControllableEntity().

void orxonox::ControllableEntity::switchCamera | ( |  | ) | `[virtual]`

References orxonox::WorldEntity::attachToNode(), camera_, cameraPositionRootNode_, cameraPositions_, and orxonox::WorldEntity::getParent().

Referenced by orxonox::HumanController::switchCamera().

void orxonox::ControllableEntity::tick | ( | float | dt | ) | `[virtual]`

Gets called every frame.

Parameters:

  | dt | The time since the last frame in seconds

Reimplemented from orxonox::MobileEntity.

Reimplemented in orxonox::Pawn, orxonox::SpaceShip, orxonox::Spectator, and orxonox::PongBat.

References bHasLocalController_, client_angular_velocity_, client_linear_velocity_, client_orientation_, client_position_, orxonox::MobileEntity::getAngularVelocity(), orxonox::WorldEntity::getOrientation(), orxonox::WorldEntity::getPosition(), orxonox::MobileEntity::getVelocity(), orxonox::BaseObject::isActive(), orxonox::WorldEntity::isDynamic(), orxonox::GameMode::isMaster(), server_angular_velocity_, server_linear_velocity_, server_orientation_, server_position_, and orxonox::MobileEntity::tick().

virtual void orxonox::ControllableEntity::useItem | ( |  | ) | `[inline, virtual]`

Reimplemented in orxonox::Pawn.

Referenced by orxonox::HumanController::useItem().

void orxonox::ControllableEntity::XMLPort | ( | Element & | xmlelement,
|  | XMLPort::Mode | mode |
| ) |  |  | `[virtual]`

XML loading and saving.

Parameters:

  | xmlelement | The XML-element
  | loading | Loading (true) or saving (false)

Returns:
  The XML-element

Reimplemented from orxonox::MobileEntity.

Reimplemented in orxonox::Pawn, and orxonox::SpaceShip.

References addCameraPosition(), getCameraPosition(), getCameraPositionTemkplate(), getHudTemplate(), getXMLController(), setCameraPositionTemplate(), setHudTemplate(), setXMLController(), SUPER, XMLPortObject, and XMLPortParam.

## Friends And Related Function Documentation

friend class PlayerInfo`[friend]`

## Member Data Documentation

bool orxonox::ControllableEntity::bDestroyWhenPlayerLeft_`[private]`

Referenced by ControllableEntity(), removePlayer(), and ~ControllableEntity().

bool orxonox::ControllableEntity::bHasHumanController_`[private]`

Referenced by ControllableEntity(), removePlayer(), setPlayer(), and ~ControllableEntity().

bool orxonox::ControllableEntity::bHasLocalController_`[private]`

Referenced by ControllableEntity(), processOverwrite(), processServerAngularVelocity(), processServerLinearVelocity(), processServerOrientation(), processServerPosition(), removePlayer(), setAngularVelocity(), setOrientation(), setPlayer(), setPosition(), setVelocity(), setWorldTransform(), setXMLController(), tick(), and ~ControllableEntity().

bool orxonox::ControllableEntity::bMouseLook_`[private]`

Referenced by ControllableEntity(), mouseLook(), rotatePitch(), rotateRoll(), and rotateYaw().

Camera* orxonox::ControllableEntity::camera_`[private]`

Referenced by ControllableEntity(), startLocalHumanControl(), stopLocalHumanControl(), switchCamera(), and ~ControllableEntity().

Ogre::SceneNode* orxonox::ControllableEntity::cameraPositionRootNode_`[private]`

Referenced by ControllableEntity(), mouseLook(), rotatePitch(), rotateRoll(), rotateYaw(), startLocalHumanControl(), switchCamera(), and ~ControllableEntity().

std::list<CameraPosition*> orxonox::ControllableEntity::cameraPositions_`[private]`

Referenced by addCameraPosition(), getCameraPosition(), parentChanged(), startLocalHumanControl(), switchCamera(), and ~ControllableEntity().

std::string orxonox::ControllableEntity::cameraPositionTemplate_`[private]`

Referenced by registerVariables(), and startLocalHumanControl().

Vector3 orxonox::ControllableEntity::client_angular_velocity_`[private]`

Referenced by ControllableEntity(), processClientAngularVelocity(), registerVariables(), setAngularVelocity(), setWorldTransform(), and tick().

Vector3 orxonox::ControllableEntity::client_linear_velocity_`[private]`

Referenced by ControllableEntity(), processClientLinearVelocity(), registerVariables(), setVelocity(), setWorldTransform(), and tick().

Quaternion orxonox::ControllableEntity::client_orientation_`[private]`

Referenced by ControllableEntity(), processClientOrientation(), registerVariables(), setOrientation(), setWorldTransform(), and tick().

unsigned int orxonox::ControllableEntity::client_overwrite_`[private]`

Referenced by ControllableEntity(), processClientAngularVelocity(), processClientLinearVelocity(), processClientOrientation(), processClientPosition(), processOverwrite(), registerVariables(), and setPlayer().

Vector3 orxonox::ControllableEntity::client_position_`[private]`

Referenced by ControllableEntity(), processClientPosition(), registerVariables(), setPosition(), setWorldTransform(), and tick().

OverlayGroup* orxonox::ControllableEntity::hud_`[private]`

Referenced by ControllableEntity(), startLocalHumanControl(), stopLocalHumanControl(), and ~ControllableEntity().

std::string orxonox::ControllableEntity::hudtemplate_`[private]`

Referenced by registerVariables(), and startLocalHumanControl().

float orxonox::ControllableEntity::mouseLookSpeed_`[private]`

Referenced by ControllableEntity(), and setConfigValues().

PlayerInfo* orxonox::ControllableEntity::player_`[private]`

Referenced by ControllableEntity(), networkcallback_changedplayerID(), removePlayer(), and setPlayer().

unsigned int orxonox::ControllableEntity::playerID_`[private]`

Referenced by ControllableEntity(), networkcallback_changedplayerID(), registerVariables(), removePlayer(), and setPlayer().

CameraPosition* orxonox::ControllableEntity::reverseCamera_`[private]`

Referenced by ControllableEntity().

Vector3 orxonox::ControllableEntity::server_angular_velocity_`[private]`

Referenced by ControllableEntity(), processClientAngularVelocity(), processOverwrite(), processServerAngularVelocity(), registerVariables(), setAngularVelocity(), setWorldTransform(), and tick().

Vector3 orxonox::ControllableEntity::server_linear_velocity_`[private]`

Referenced by ControllableEntity(), processClientLinearVelocity(), processOverwrite(), processServerLinearVelocity(), registerVariables(), setVelocity(), setWorldTransform(), and tick().

Quaternion orxonox::ControllableEntity::server_orientation_`[private]`

Referenced by ControllableEntity(), processClientOrientation(), processOverwrite(), processServerOrientation(), registerVariables(), setOrientation(), setWorldTransform(), and tick().

unsigned int orxonox::ControllableEntity::server_overwrite_`[private]`

Referenced by ControllableEntity(), processClientAngularVelocity(), processClientLinearVelocity(), processClientOrientation(), processClientPosition(), processOverwrite(), registerVariables(), setAngularVelocity(), setOrientation(), setPlayer(), setPosition(), and setVelocity().

Vector3 orxonox::ControllableEntity::server_position_`[private]`

Referenced by ControllableEntity(), processClientPosition(), processOverwrite(), processServerPosition(), registerVariables(), setPosition(), setWorldTransform(), and tick().

Controller* orxonox::ControllableEntity::xmlcontroller_`[private]`

Referenced by ControllableEntity(), setXMLController(), and ~ControllableEntity().

The documentation for this class was generated from the following files:

- src/orxonox/objects/worldentities/ControllableEntity.h
- src/orxonox/objects/worldentities/ControllableEntity.cc